using System.Collections.Generic;

namespace JamesKovacs.FlexibleSoftware.Domain {
    public class CustomerRepositoryAuditor : ICustomerRepository {
        private readonly ICustomerRepository m_Repo;

        public CustomerRepositoryAuditor(ICustomerRepository repo) {
            m_Repo = repo;
        }

        #region ICustomerRepository Members

        public Customer FindById(int id) {
            AuditAccess(id);
            return m_Repo.FindById(id);
        }

        public IList<Customer> FindByProperty(string property, bool value) {
            AuditAccess(property);
            return m_Repo.FindByProperty(property, value);
        }

        private void AuditAccess(int id) {
            // Do auditing
        }

        private void AuditAccess(string prop) {
            // Do auditing
        }

        #endregion
    }
}