using System.Collections.Generic;
using JamesKovacs.Common;

namespace JamesKovacs.FlexibleSoftware.Domain {
    public class CustomerService {
        private readonly ICustomerRepository m_Repo;

        public CustomerService() : this(IoC.Resolve<ICustomerRepository>()) {
        }

        public CustomerService(ICustomerRepository customerRepository) {
            m_Repo = customerRepository;
        }

        public Customer FindById(int id) {
            return m_Repo.FindById(id);
        }

        public IList<Customer> FindDelinqentCustomers() {
            return m_Repo.FindByProperty("delinquent", true);
        }
    }
}