using System.Collections.Generic;
using JamesKovacs.FlexibleSoftware.Domain;
using NUnit.Framework;

namespace JamesKovacs.FlexibleSoftware.Tests.Domain {
    [TestFixture]
    public class CustomerServiceTests {
        [Test]
        public void CanFindCustomerById() {
            CustomerService service = new CustomerService(new FakeCustomerRepository());
            Customer customer = service.FindById(42);
            Assert.IsNotNull(customer);
        }

        [Test]
        public void CanFindDeliquentCustomers() {
            CustomerService service = new CustomerService(new FakeCustomerRepository());
            IList<Customer> customers = service.FindDelinqentCustomers();
            Assert.IsNotNull(customers);
            foreach(Customer c in customers) {
                Assert.IsTrue(c.Delinquent);
            }
        }
    }

    internal class FakeCustomerRepository : ICustomerRepository {
        #region ICustomerRepository Members

        public Customer FindById(int id) {
            return new Customer();
        }

        public IList<Customer> FindByProperty(string property, bool value) {
            List<Customer> customers = new List<Customer>();
            Customer item = new Customer();
            item.Delinquent = true;
            customers.Add(item);
            return customers;
        }

        #endregion
    }
}